##########################################################################################
#--Extracts and (when necessary) combines the municipal boundaries to correspond to the
#-----units geo-referenced in the income surveys and censuses. 
###########################################################################################


# Import system modules
import sys, string, os, arcgisscripting

# Create the Geoprocessor object
gp = arcgisscripting.create()

# Load required toolboxes...
gp.AddToolbox("C:/Program Files/ArcGIS/ArcToolbox/Toolboxes/Analysis Tools.tbx")
gp.AddToolbox("C:/Program Files/ArcGIS/ArcToolbox/Toolboxes/Data Management Tools.tbx")

#Turn overwrite on
gp.overwriteoutput = 1
print "overwrite on"

# Set directory path
gp.workspace = "INSERT DIRECTORY PATH HERE"
print "directroy set"


###------------Select boundaries from Latin America map country-by-country
#lac_admin_03_shp is the name of the boundaries data from CIAT

# Local variables...
BR_shp = "BR.shp"
lac_admin_03_shp = "lac_admin_03.shp"
BL_shp = "BL.shp"
CI_shp = "CI.shp"
CO_shp = "CO.shp"
EC_shp = "EC.shp"
ES_shp = "ES.shp"
GT_shp = "GT.shp"
HO_shp = "HO.shp"
PM_shp = "PM.shp"
PA_shp = "PA.shp"
UY_shp = "UY.shp"
VE_shp = "VE.shp"

# Process: Select...
gp.Select_analysis(lac_admin_03_shp, BR_shp, "\"PAIS\" = 'BRASIL'")

# Process: Select (2)...
gp.Select_analysis(lac_admin_03_shp, BL_shp, "\"PAIS\" = 'BOLIVIA'")

# Process: Select (3)...
gp.Select_analysis(lac_admin_03_shp, CI_shp, "\"PAIS\" = 'CHILE'")

# Process: Select (4)...
gp.Select_analysis(lac_admin_03_shp, CO_shp, "\"PAIS\" = 'COLOMBIA'")

# Process: Select (5)...
gp.Select_analysis(lac_admin_03_shp, EC_shp, "\"PAIS\" = 'ECUADOR'")

# Process: Select (6)...
gp.Select_analysis(lac_admin_03_shp, ES_shp, "\"PAIS\" = 'EL SALVADOR'")

# Process: Select (7)...
gp.Select_analysis(lac_admin_03_shp, GT_shp, "\"PAIS\" = 'GUATEMALA'")

# Process: Select (8)...
gp.Select_analysis(lac_admin_03_shp, HO_shp, "\"PAIS\" = 'HONDURAS'")

# Process: Select (9)...
gp.Select_analysis(lac_admin_03_shp, PM_shp, "\"PAIS\" = 'PANAMA'")

# Process: Select (10)...
gp.Select_analysis(lac_admin_03_shp, PA_shp, "\"PAIS\" = 'PARAGUAY'")

# Process: Select (11)...
gp.Select_analysis(lac_admin_03_shp, UY_shp, "\"PAIS\" = 'URUGUAY'")

# Process: Select (12)...
gp.Select_analysis(lac_admin_03_shp, VE_shp, "\"PAIS\" = 'VENEZUELA'")


print "finished extracting boundaries from CIAT map country-by-country"

###---Transform CIAT boundaries to census/survey boundaries

#---The CIAT boundaries are at the municipal level whereas some censuses
#--and surveys are at the regional level and others combine small municipalities
#--for confidentiality reasons. The following commands create boundaries,
#--country-by-country, for the geographic divisions used for each country
#--in our income database.

#--cancd_shp is the boundaries file from the Canadian census bureau.
#--us_nprj_shp is the boundaries file from the U.S. census bureau.

# Local variables...
BR_Layer = "BR_Layer"
BRcensus3_shp = "BRcensus3.shp"
BR_shp = "BR.shp"
BR3codes_dbf = "BR3codes.dbf"
BLsurvey2_shp = "BLsurvey2.shp"
BL_shp = "BL.shp"
CILayer = "CILayer"
CI_shp = "CI.shp"
CI1codes_dbf = "CI1codes.dbf"
CIsurvey1_shp = "CIsurvey1.shp"
CO_Layer = "CO_Layer"
CO_shp = "CO.shp"
COcodes_dbf = "COcodes.dbf"
COsurvey1_shp = "COsurvey1.shp"
EC_Layer = "EC_Layer"
EC_shp = "EC.shp"
EC1codes_dbf = "EC1codes.dbf"
ECsurvey1_shp = "EC_survey1.shp"
ES_Layer = "ES_Layer"
ES_shp = "ES.shp"
EScodes_dbf = "EScodes.dbf"
ESsurvey3_shp = "ESsurvey3.shp"
GTsurvey3_shp = "GTsurvey3.shp"
HOsurvey3_shp = "HOsurvey3.shp"
GT_shp = "GT.shp"
HO_shp = "HO.shp"
MXcensus3_shp = "MXcensus3.shp"
mx_nprj_shp = "mx_nprj.shp"
PM_Layer = "PM_Layer"
PM_shp = "PM.shp"
PMcodes_dbf = "PMcodes.dbf"
PMcensus3_shp = "PMcensus3.shp"
PAsurvey3_shp = "PAsurvey3.shp"
PA_shp = "PA.shp"
PE_shp = "PE.shp"
distritos_shp = "distritos.shp"
PEsurvey3_shp = "PEsurvey3.shp"
UY_Layer = "UY_Layer"
UY_shp = "UY.shp"
UYcodes_dbf = "UYcodes.dbf"
UYsurvey1_shp = "UYsurvey1.shp"
VE_Layer = "VE_Layer"
VE_shp = "VE.shp"
VE3codes_dbf = "VE3codes.dbf"
VEcensus3_shp = "VEcensus3.shp"
UScensus3_shp = "UScensus3.shp"
us_nprj_shp = "us_nprj.shp"
cancd_Layer = "cancd_Layer"
cancd_shp = "cancd.shp"
CA1codes_dbf = "CA1codes.dbf"
CAcensus1_shp = "CAcensus1.shp"
mx_nprj_Layer = "mx_nprj_Layer"
mx_nprj_shp = "mx_nprj.shp"
MXcodes_dbf = "MXcodes.dbf"
MXcensus3_shp = "MXcensus3.shp"

# Process: Make Feature Layer...
gp.MakeFeatureLayer_management(BR_shp, BR_Layer, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join...
gp.AddJoin_management(BR_Layer, "DIS", BR3codes_dbf, "DIS", "KEEP_ALL")

# Process: Dissolve...
gp.Dissolve_management(BR_Layer, BRcensus3_shp, "BR3codes.ADMIN3", "", "MULTI_PART")

# Process: Dissolve (2)...
gp.Dissolve_management(BL_shp, BLsurvey2_shp, "MUN", "", "MULTI_PART")

# Process: Make Feature Layer...
gp.MakeFeatureLayer_management(CI_shp, CILayer, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join...
gp.AddJoin_management(CILayer, "MUN", CI1codes_dbf, "MUN", "KEEP_ALL")

# Process: Dissolve (3)...
gp.Dissolve_management(CILayer, CIsurvey1_shp, "CI1codes.ADMIN1", "", "MULTI_PART")

# Process: Make Feature Layer (2)...
gp.MakeFeatureLayer_management(CO_shp, CO_Layer, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join (2)...
gp.AddJoin_management(CO_Layer, "MUN", COcodes_dbf, "MUN", "KEEP_ALL")

# Process: Dissolve (4)...
gp.Dissolve_management(CO_Layer, COsurvey1_shp, "COcodes.ADMIN1", "", "MULTI_PART")

# Process: Make Feature Layer (3)...
gp.MakeFeatureLayer_management(EC_shp, EC_Layer, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join (3)...
gp.AddJoin_management(EC_Layer, "MUN", EC1codes_dbf, "MUN", "KEEP_ALL")

# Process: Dissolve (5)...
gp.Dissolve_management(EC_Layer, ECsurvey1_shp, "EC1codes.ADMIN1", "", "MULTI_PART")

# Process: Make Feature Layer (4)...
gp.MakeFeatureLayer_management(ES_shp, ES_Layer, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join (4)...
gp.AddJoin_management(ES_Layer, "MUN", EScodes_dbf, "MUN", "KEEP_ALL")

# Process: Dissolve (6)...
gp.Dissolve_management(ES_Layer, ESsurvey3_shp, "EScodes.ADMIN3", "", "MULTI_PART")

# Process: Dissolve (7)...
gp.Dissolve_management(GT_shp, GTsurvey3_shp, "MUN", "", "MULTI_PART")

# Process: Dissolve (8)...
gp.Dissolve_management(HO_shp, HOsurvey3_shp, "MUN", "", "MULTI_PART")

# Process: Make Feature Layer...
gp.MakeFeatureLayer_management(mx_nprj_shp, mx_nprj_Layer, "", "", "MUN_NAME MUN_NAME VISIBLE;ST_NAME ST_NAME VISIBLE;ST_MUN_ID ST_MUN_ID VISIBLE;ST_ID ST_ID VISIBLE;MUN_ID MUN_ID VISIBLE;SQKM SQKM VISIBLE;COLORMAP COLORMAP VISIBLE;OBJECTID OBJECTID VISIBLE;GEOMETRY_A GEOMETRY_A VISIBLE;GEOMETRY_L GEOMETRY_L VISIBLE;cid cid VISIBLE;sarea sarea VISIBLE")

# Process: Add Join...
gp.AddJoin_management(mx_nprj_Layer, "ST_MUN_ID", MXcodes_dbf, "ST_MUN_ID", "KEEP_ALL")

# Process: Dissolve...
gp.Dissolve_management(mx_nprj_Layer, MXcensus3_shp, "MXcodes.ADMIN3", "", "MULTI_PART")


# Process: Make Feature Layer (5)...
gp.MakeFeatureLayer_management(PM_shp, PM_Layer, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join (5)...
gp.AddJoin_management(PM_Layer, "MUN", PMcodes_dbf, "MUN", "KEEP_ALL")

# Process: Dissolve (10)...
gp.Dissolve_management(PM_Layer, PMcensus3_shp, "PMcodes.ADMIN3", "", "MULTI_PART")

# Process: Dissolve (11)...
gp.Dissolve_management(PA_shp, PAsurvey3_shp, "MUN", "", "MULTI_PART")

# Process: Project...
gp.Project_management(distritos_shp, PE_shp, "GEOGCS['GCS_WGS_1984',DATUM['D_WGS_1984',SPHEROID['WGS_1984',6378137.0,298.257223563]],PRIMEM['Greenwich',0.0],UNIT['Degree',0.0174532925199433]]", "", "PROJCS['WGS_1984_UTM_Zone_18S',GEOGCS['GCS_WGS_1984',DATUM['D_WGS_1984',SPHEROID['WGS_1984',6378137.0,298.257223563]],PRIMEM['Greenwich',0.0],UNIT['Degree',0.0174532925199433]],PROJECTION['Transverse_Mercator'],PARAMETER['False_Easting',500000.0],PARAMETER['False_Northing',10000000.0],PARAMETER['Central_Meridian',-75.0],PARAMETER['Scale_Factor',0.9996],PARAMETER['Latitude_Of_Origin',0.0],UNIT['Meter',1.0]]")

# Process: Dissolve (12)...
gp.Dissolve_management(PE_shp, PEsurvey3_shp, "CODIGO_DIS", "", "MULTI_PART")

# Process: Make Feature Layer (6)...
gp.MakeFeatureLayer_management(UY_shp, UY_Layer, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join (6)...
gp.AddJoin_management(UY_Layer, "DEP", UYcodes_dbf, "DEP", "KEEP_ALL")

# Process: Dissolve (13)...
gp.Dissolve_management(UY_Layer, UYsurvey1_shp, "UYcodes.ADMIN1", "", "MULTI_PART")

# Process: Make Feature Layer (7)...
gp.MakeFeatureLayer_management(VE_shp, VE_Layer, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join (7)...
gp.AddJoin_management(VE_Layer, "MUN", VE3codes_dbf, "MUN", "KEEP_ALL")

# Process: Dissolve (14)...
gp.Dissolve_management(VE_Layer, VEcensus3_shp, "VE3codes.CENS_MUN", "", "MULTI_PART")

# Process: Add Field...
gp.AddField_management(us_nprj_shp, "admin3", "LONG", "", "", "", "", "NON_NULLABLE", "NON_REQUIRED", "")

# Process: Calculate Field...
gp.CalculateField_management(us_nprj_shp, "admin3", "[PUMA5]+10000* [STATE]", "VB", "")

# Process: Dissolve (15)...
gp.Dissolve_management(us_nprj_shp, UScensus3_shp, "admin3", "", "MULTI_PART")

# Process: Make Feature Layer (8)...
gp.MakeFeatureLayer_management(cancd_shp, cancd_Layer, "", "", "AREA AREA VISIBLE;PERIMETER PERIMETER VISIBLE;GECD00E02A GECD00E02A VISIBLE;GECD00E0_1 GECD00E0_1 VISIBLE;CDNAME CDNAME VISIBLE;CDUID CDUID VISIBLE;CDTYPE CDTYPE VISIBLE;PRUID PRUID VISIBLE;WATER WATER VISIBLE")

# Process: Add Join (8)...
gp.AddJoin_management(cancd_Layer, "PRUID", CA1codes_dbf, "PRUID", "KEEP_ALL")

# Process: Dissolve (16)...
gp.Dissolve_management(cancd_Layer, CAcensus1_shp, "CA1codes.ADMIN1", "", "MULTI_PART")



print "finished creating boundaries that confirm to census/survey boundaries"


#---Create polygon ids for zonal statistics

#---ArcGIS will crash if the ids for the zonal field are too long.
#---Hence for several of the countries it is necessary to create
#---a shorter id for each polygon. 

# Process: Add Field...
gp.AddField_management(BRcensus3_shp, "cid", "LONG", "", "", "", "", "NON_NULLABLE", "NON_REQUIRED", "")

# Process: Calculate Field...
gp.CalculateField_management(BRcensus3_shp, "cid", "[FID]+1", "VB", "")

# Process: Add Field...
gp.AddField_management(UScensus3_shp, "cid", "LONG", "", "", "", "", "NON_NULLABLE", "NON_REQUIRED", "")

# Process: Calculate Field...
gp.CalculateField_management(UScensus3_shp, "cid", "[FID]+1", "VB", "")

# Process: Add Field...
VEcensus3_shp = "VEcensus3.shp"
gp.AddField_management(VEcensus3_shp, "cid", "LONG", "", "", "", "", "NON_NULLABLE", "NON_REQUIRED", "")

# Process: Calculate Field...
gp.CalculateField_management(VEcensus3_shp, "cid", "[FID]+1", "VB", "")



##################################################################
#--Boundaries for calculating inequality in proximity to roads
#--To be consistent across countries, all boundaries correspond
#--to the finest geographic unit to which economic data are
#--geo-referenced in either the IPUMS census
#--database or our household survey database. In all cases
#--except Uruguay and the U.S., this corresponds to the
#--municipality. (In some countries, municipalities with less than
#--10,000 or 20,000 people are combined with other nearby
#--small municipalities for confidentiality reasons.) In Uruguay,
#--the unit is a province (of which there are 19) and in the
#--U.S., it is a public use micro area (5% PUMS). 
##################################################################


# Local variables...
NU_shp = "NU.shp"
lac_admin_03_shp = "lac_admin_03.shp"
NUsurvey3_shp = "NUsurvey3.shp"
CR_Layer = "CR_Layer"
CR_shp = "CR.shp"
CRed_codes_dbf = "CRed_codes.dbf"
CRcensus3_shp = "CRcensus3.shp"
CO_Layer2 = "CO_Layer2"
EC_Layer2 = "EC_Layer2"
CO_shp = "CO.shp"
EC_shp = "EC.shp"
COcensus_codes_dbf = "COcensus_codes.dbf"
ECcensus_dbf = "ECcensus.dbf"
COcensus3_shp = "COcensus3.shp"
ECcensus3_shp = "ECcensus3.shp"
AR_shp = "AR.shp"
AR_Layer = "AR_Layer"
codes4AR_dbf = "codes4AR.dbf"
ARcensus3_shp = "ARcensus3.shp"
CI_Layer2 = "CI_Layer2"
CI_shp = "CI.shp"
CIcensus_codes_dbf = "CIcensus_codes.dbf"
CIcensus3_shp = "CIcensus3.shp"

# Process: Select...
gp.Select_analysis(lac_admin_03_shp, NU_shp, "\"PAIS\" = 'NICARAGUA'")

# Process: Dissolve...
gp.Dissolve_management(NU_shp, NUsurvey3_shp, "MUN", "", "MULTI_PART")

# Process: Select (2)...
gp.Select_analysis(lac_admin_03_shp, CR_shp, "\"PAIS\" = 'COSTA RICA'")

# Process: Make Feature Layer...
gp.MakeFeatureLayer_management(CR_shp, CR_Layer, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join...
gp.AddJoin_management(CR_Layer, "MUN", CRed_codes_dbf, "MUN", "KEEP_ALL")

# Process: Dissolve (2)...
gp.Dissolve_management(CR_Layer, CRcensus3_shp, "CRed_codes.CENS_PROV", "", "MULTI_PART")

# Process: Make Feature Layer (2)...
gp.MakeFeatureLayer_management(CO_shp, CO_Layer2, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join (2)...
gp.AddJoin_management(CO_Layer2, "MUN", COcensus_codes_dbf, "MUN", "KEEP_ALL")

# Process: Dissolve (3)...
gp.Dissolve_management(CO_Layer2, COcensus3_shp, "COcensus_codes.CENSUS_COD", "", "MULTI_PART")

# Process: Make Feature Layer (3)...
gp.MakeFeatureLayer_management(EC_shp, EC_Layer2, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join (3)...
gp.AddJoin_management(EC_Layer2, "MUN", ECcensus_dbf, "CENS_CANT", "KEEP_ALL")

# Process: Dissolve (4)...
gp.Dissolve_management(EC_Layer2, ECcensus3_shp, "ECcensus.CENS_CANT", "", "MULTI_PART")

# Process: Select (3)...
gp.Select_analysis(lac_admin_03_shp, AR_shp, "\"PAIS\" = 'ARGENTINA'")

# Process: Make Feature Layer (4)...
gp.MakeFeatureLayer_management(AR_shp, AR_Layer, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join (4)...
gp.AddJoin_management(AR_Layer, "MUN", codes4AR_dbf, "MUN", "KEEP_ALL")

# Process: Dissolve (5)...
gp.Dissolve_management(AR_Layer, ARcensus3_shp, "codes4AR.MUN", "", "MULTI_PART")

# Process: Make Feature Layer (5)...
gp.MakeFeatureLayer_management(CI_shp, CI_Layer2, "", "", "OBJECTID OBJECTID VISIBLE;PERIMETER PERIMETER VISIBLE;X_ X_ VISIBLE;X_ID X_ID VISIBLE;PAIS PAIS VISIBLE;ADMIN_L2 ADMIN_L2 VISIBLE;ADMIN_L3 ADMIN_L3 VISIBLE;ADMIN_L4 ADMIN_L4 VISIBLE;ISO ISO VISIBLE;ISO_N ISO_N VISIBLE;DEP DEP VISIBLE;MUN MUN VISIBLE;DIS DIS VISIBLE;ISODEPMUN ISODEPMUN VISIBLE;OTROS OTROS VISIBLE;COMENTARIO COMENTARIO VISIBLE;CREADOR CREADOR VISIBLE;EDITOR EDITOR VISIBLE;F_CREACION F_CREACION VISIBLE;F_ACTUALIZ F_ACTUALIZ VISIBLE;SHAPE_LENG SHAPE_LENG VISIBLE;SHAPE_AREA SHAPE_AREA VISIBLE;NIVEL_DATO NIVEL_DATO VISIBLE;Mix Mix VISIBLE")

# Process: Add Join (5)...
gp.AddJoin_management(CI_Layer2, "ADMIN_L4", CIcensus_codes_dbf, "ADMIN_L4", "KEEP_ALL")

# Process: Dissolve (6)...
gp.Dissolve_management(CI_Layer2, CIcensus3_shp, "CIcensus_codes.CENS_MUN", "", "MULTI_PART")


# Process: Add Field...
gp.AddField_management(CIcensus3_shp, "cid", "LONG", "", "", "", "", "NON_NULLABLE", "NON_REQUIRED", "")

# Process: Calculate Field...
gp.CalculateField_management(CIcensus3_shp, "cid", "[FID]+1", "VB", "")

# Process: Add Field...
gp.AddField_management(COcensus3_shp, "cid", "LONG", "", "", "", "", "NON_NULLABLE", "NON_REQUIRED", "")

# Process: Calculate Field...
gp.CalculateField_management(COcensus3_shp, "cid", "[FID]+1", "VB", "")

# Process: Add Field...
gp.AddField_management(CRcensus3_shp, "cid", "LONG", "", "", "", "", "NON_NULLABLE", "NON_REQUIRED", "")

# Process: Calculate Field...
gp.CalculateField_management(CRcensus3_shp, "cid", "[FID]+1", "VB", "")

# Process: Add Field...
gp.AddField_management(ECcensus3_shp, "cid", "LONG", "", "", "", "", "NON_NULLABLE", "NON_REQUIRED", "")

# Process: Calculate Field...
gp.CalculateField_management(ECcensus3_shp, "cid", "[FID]+1", "VB", "")

