#---------------------------------------------------------------------------
# This file calculates mean temperature and precipitation weighted by
# landmass for third level admin units (census countries)
# ---------------------------------------------------------------------------

# Import system modules
import sys, string, os, arcgisscripting, shutil
print "modules imported"

# Create the Geoprocessor object
gp = arcgisscripting.create()

#Turn overwrite on
gp.overwriteoutput = 1
print "overwrite on"

# Check out any necessary licenses
gp.CheckOutExtension("spatial")

# Load required toolboxes...
gp.AddToolbox("E:/Program Files/ArcGIS/ArcToolbox/Toolboxes/Spatial Analyst Tools.tbx")
gp.AddToolbox("E:/Program Files/ArcGIS/ArcToolbox/Toolboxes/Analysis Tools.tbx")
gp.AddToolbox("E:/Program Files/ArcGIS/ArcToolbox/Toolboxes/Data Management Tools.tbx")


# Set directory path
gp.workspace = "INSERT DIRECTORY PATH HERE"
print "directroy set"


####----------Calculate municipal level climate averages, country-by-country


#---Note: typically when calculating areas within polygons, one would
#---want to project the data to an equal area coordinate system.
#---However, municipalities are so small that very little distortion
#---is introduced taking avareges with the data in a geographic
#---coordinate system, and more error in fact may be introduced
#---by resampling the raster in order to project it. Hence, I calculate
#---averages with all layers in WGS1984. 

#----Precipitation

for month in range (0, 12):
    month=month+1
    print str(month)
    
    #Process: Create directory
    os.mkdir("INSERT TEMPORARY DIRECTORY PATH HERE")
    print "directory created"

    #Set directory path
    gp.workspace = "INSERT TEMPORARY DIRECTORY PATH HERE"
    print "directroy set"


    pre = "WorldClim\\prec\\prec_"+str(month)
    #These are files from World Clim

    #------Brazil

    # Process: Zonal Statistics as Table ...
    BRcensus3 = "BRcensus3.shp"
    meanpre_BR = "meanpre_BR"+str(month) 
    gp.ZonalStatisticsAsTable_sa(BRcensus3, "cid", pre, meanpre_BR, "DATA")
    print "calculated mean of monthly precipitation within each district"

    # Process: Table Select ...
    meanpre_BR_dbf = "preBR"+str(month)+".dbf"
    gp.TableSelect_analysis(meanpre_BR, meanpre_BR_dbf, "")
    print "exported BR precip data to .dbf file"


   #####--------Mexico

    # Process: Zonal Statistics as Table...
    MXcensus3="MXcensus3.shp"
    meanpre_MX = "meanpre_MX"+str(month)
    gp.ZonalStatisticsAsTable_sa(MXcensus3, "MXcodes_AD", pre, meanpre_MX, "DATA")
    print "calculated mean precipitation for MX munics"

    # Process: Table Select...
    meanpre_MX_dbf="preMX"+str(month)+".dbf"
    gp.TableSelect_analysis(meanpre_MX, meanpre_MX_dbf, "")
    print "exported to .dbf file"




    #####--------Panama

    # Process: Zonal Statistics as Table...
    PMcensus3="PMcensus3.shp"
    meanpre_PM = "meanpre_PM"+str(month)
    gp.ZonalStatisticsAsTable_sa(PMcensus3, "PMcodes.ADMIN3", pre, meanpre_PM, "DATA")
    print "calculated mean precipitation for PM munics"

    # Process: Table Select...
    meanpre_PM_dbf="prePM"+str(month)+".dbf"
    gp.TableSelect_analysis(meanpre_PM, meanpre_PM_dbf, "")
    print "exported to .dbf file"



    #####--------Venezuela

    # Process: Zonal Statistics as Table...
    VEcensus3="VEcensus3.shp"
    meanpre_VE = "meanpre_VE"+str(month)
    gp.ZonalStatisticsAsTable_sa(VEcensus3, "VE3codes_C", pre, meanpre_VE, "DATA")
    print "calculated mean precipitation for VE munics"

    # Process: Table Select...
    meanpre_VE_dbf="preVE"+str(month)+".dbf"
    gp.TableSelect_analysis(meanpre_VE, meanpre_VE_dbf, "")
    print "exported to .dbf file"



    
    #####--------US

    # Process: Zonal Statistics as Table...
    UScensus3="UScensus3.shp"
    meanpre_US = "meanpre_US"+str(month)
    gp.ZonalStatisticsAsTable_sa(UScensus3, "cid", pre, meanpre_US, "DATA")
    print "calculated mean precipitation for US munics"

    # Process: Table Select...
    meanpre_US_dbf="preUS"+str(month)+".dbf"
    gp.TableSelect_analysis(meanpre_US, meanpre_US_dbf, "")
    print "exported to .dbf file"


    #Process: Delete Directory... 
    shutil.rmtree("INSERT TEMPORARY DIRECTORY PATH HERE")

    print str(month)

for month in range (0, 12):
    month=month+1
    print str(month)
    
    #Process: Create directory
    os.mkdir("INSERT TEMPORARY DIRECTORY PATH HERE")
    print "directory created"

    #Set directory path
    gp.workspace = "INSERT TEMPORARY DIRECTORY PATH HERE"
    print "directroy set"

    max = "WorldClim\\tmax\\tmax_"+str(month)
    #These are files from World Clim

    #----BR

    # Process: Zonal Statistics as Table...
    BRcensus3="BRcensus3.shp"
    meanmax_BR = "meanmax_BR"+str(month)
    gp.ZonalStatisticsAsTable_sa(BRcensus3, "cid", max, meanmax_BR, "DATA")
    print "calculated mean precipitation for BR munics"

    # Process: Table Select...
    meanmax_BR_dbf="maxBR"+str(month)+".dbf"
    gp.TableSelect_analysis(meanmax_BR, meanmax_BR_dbf, "")
    print "exported to .dbf file"
    

    

    #----MX

    # Process: Zonal Statistics as Table...
    MXcensus3="MXcensus3.shp"
    meanmax_MX = "meanmax_MX"+str(month)
    gp.ZonalStatisticsAsTable_sa(MXcensus3, "MXcodes_AD", max, meanmax_MX, "DATA")
    print "calculated mean precipitation for MX munics"

    # Process: Table Select...
    meanmax_MX_dbf="maxMX"+str(month)+".dbf"
    gp.TableSelect_analysis(meanmax_MX, meanmax_MX_dbf, "")
    print "exported to .dbf file"
    



    #----PM

    # Process: Zonal Statistics as Table...
    PMcensus3="PMcensus3.shp"
    meanmax_PM = "meanmax_PM"+str(month)
    gp.ZonalStatisticsAsTable_sa(PMcensus3, "PMcodes.ADMIN3", max, meanmax_PM, "DATA")
    print "calculated mean precipitation for PM munics"

    # Process: Table Select...
    meanmax_PM_dbf="maxPM"+str(month)+".dbf"
    gp.TableSelect_analysis(meanmax_PM, meanmax_PM_dbf, "")
    print "exported to .dbf file"
    


    #----US

    # Process: Zonal Statistics as Table...
    UScensus3="UScensus3.shp"
    meanmax_US = "meanmax_US"+str(month)
    gp.ZonalStatisticsAsTable_sa(UScensus3, "cid", max, meanmax_US, "DATA")
    print "calculated mean precipitation for US munics"

    # Process: Table Select...
    meanmax_US_dbf="maxUS"+str(month)+".dbf"
    gp.TableSelect_analysis(meanmax_US, meanmax_US_dbf, "")
    print "exported to .dbf file"
    
        

    #----VE

    # Process: Zonal Statistics as Table...
    VEcensus3="VEcensus3.shp"
    meanmax_VE = "meanmax_VE"+str(month)
    gp.ZonalStatisticsAsTable_sa(VEcensus3, "VE3codes_C", max, meanmax_VE, "DATA")
    print "calculated mean precipitation for VE munics"

    # Process: Table Select...
    meanmax_VE_dbf="maxVE"+str(month)+".dbf"
    gp.TableSelect_analysis(meanmax_VE, meanmax_VE_dbf, "")
    print "exported to .dbf file"

  
    #Process: Delete Directory... 
    shutil.rmtree("INSERT TEMPORARY DIRECTORY PATH HERE")

    print str(month)




for month in range (0, 12):
    month=month+1
    print str(month)
    
    #Process: Create directory
    os.mkdir("INSERT TEMPORARY DIRECTORY PATH HERE")
    print "directory created"

    #Set directory path
    gp.workspace = "INSERT TEMPORARY DIRECTORY PATH HERE"
    print "directroy set"

    min = "WorldClim\\tmin\\tmin_"+str(month)
    #These are files from World Clim


    #---BR
    
    # Process: Zonal Statistics as Table...
    BRcensus3="BRcensus3.shp"
    meanmin_BR = "meanmin_BR"+str(month)
    gp.ZonalStatisticsAsTable_sa(BRcensus3, "cid", min, meanmin_BR, "DATA")
    print "calculated mean precipitation for BR munics"

    # Process: Table Select...
    meanmin_BR_dbf="minBR"+str(month)+".dbf"
    gp.TableSelect_analysis(meanmin_BR, meanmin_BR_dbf, "")
    print "exported to .dbf file"



    #---MX
    
    # Process: Zonal Statistics as Table...
    MXcensus3="MXcensus3.shp"
    meanmin_MX = "meanmin_MX"+str(month)
    gp.ZonalStatisticsAsTable_sa(MXcensus3, "MXcodes_AD", min, meanmin_MX, "DATA")
    print "calculated mean precipitation for MX munics"

    # Process: Table Select...
    meanmin_MX_dbf="minMX"+str(month)+".dbf"
    gp.TableSelect_analysis(meanmin_MX, meanmin_MX_dbf, "")
    print "exported to .dbf file"



    #---PM

    # Process: Zonal Statistics as Table...
    PMcensus3="PMcensus3.shp"
    meanmin_PM = "meanmin_PM"+str(month)
    gp.ZonalStatisticsAsTable_sa(PMcensus3, "PMcodes.ADMIN3", min, meanmin_PM, "DATA")
    print "calculated mean precipitation for PM munics"

    # Process: Table Select...
    meanmin_PM_dbf="minPM"+str(month)+".dbf"
    gp.TableSelect_analysis(meanmin_PM, meanmin_PM_dbf, "")
    print "exported to .dbf file"



    #---US

    # Process: Zonal Statistics as Table...
    UScensus3="UScensus3.shp"
    meanmin_US = "meanmin_US"+str(month)
    gp.ZonalStatisticsAsTable_sa(UScensus3, "cid", min, meanmin_US, "DATA")
    print "calculated mean precipitation for US munics"

    # Process: Table Select...
    meanmin_US_dbf="minUS"+str(month)+".dbf"
    gp.TableSelect_analysis(meanmin_US, meanmin_US_dbf, "")
    print "exported to .dbf file"


    #---VE

    # Process: Zonal Statistics as Table...
    VEcensus3="VEcensus3.shp"
    meanmin_VE = "meanmin_VE"+str(month)
    gp.ZonalStatisticsAsTable_sa(VEcensus3, "VE3codes_C", min, meanmin_VE, "DATA")
    print "calculated mean precipitation for VE munics"

    # Process: Table Select...
    meanmin_VE_dbf="minVE"+str(month)+".dbf"
    gp.TableSelect_analysis(meanmin_VE, meanmin_VE_dbf, "")
    print "exported to .dbf file"

   #Process: Delete Directory... 
    shutil.rmtree("INSERT TEMPORARY DIRECTORY PATH HERE")

    print str(month)


