#----------------------------------------------------
# This file calculates municipal population totals
# ---------------------------------------------------

# Import system modules
import sys, string, os, arcgisscripting, shutil
print "modules imported"

# Create the Geoprocessor object
gp = arcgisscripting.create()

#Turn overwrite on
gp.overwriteoutput = 1
print "overwrite on"

# Check out any necessary licenses
gp.CheckOutExtension("spatial")

# Load required toolboxes...
gp.AddToolbox("C:/Program Files/Arcgis/ArcToolbox/Toolboxes/Spatial Analyst Tools.tbx")
gp.AddToolbox("C:/Program Files/Arcgis/ArcToolbox/Toolboxes/Analysis Tools.tbx")

# Import system modules
import sys, string, os, arcgisscripting

# Create the Geoprocessor object
gp = arcgisscripting.create()

# Set the necessary product code
gp.SetProduct("ArcInfo")

# Set directory path
gp.workspace = "INSERT DIRECTORY PATH HERE"
print "directroy set"

##------Calculate population averages

# Local variables...
ARpop00 = "ARpop00"
ARcensus3_shp = "ARcensus3.shp"
BLpop00 = "BLpop00"
BLsurvey2_shp = "BLsurvey2.shp"
BRpop00 = "BRpop00"
BRcensus3_shp = "BRcensus3.shp"
CApop00 = "CApop00"
CIpop00 = "CIpop00"
COpop00 = "COpop00"
CIadmin1_shp = "CIadmin1.shp"
COsurvey1_shp = "COsurvey1.shp"
ECpop00 = "ECpop00"
ESpop00 = "ESpop00"
GTpop00 = "GTpop00"
EC_survey1_shp = "EC_survey1.shp"
CAcensus1_shp = "CAcensus1.shp"
ESsurvey3_shp = "ESsurvey3.shp"
GTsurvey3_shp = "GTsurvey3.shp"
HOpop00 = "HOpop00"
MXpop00 = "MXpop00"
PApop00 = "PApop00"
HOsurvey3_shp = "HOsurvey3.shp"
MXcensus3_shp = "MXcensus3.shp"
PAsurvey3_shp = "PAsurvey3.shp"
NUsurvey3_shp = "NUsurvey3.shp"
PEpop00 = "PEpop00"
NUpop00 = "NUpop00"
PMpop00 = "PMpop00"
USpop00 = "USpop00"
PEsurvey3_shp = "PEsurvey3.shp"
PMcensus3_shp = "PMcensus3.shp"
UScensus3_shp = "UScensus3.shp"
UYpop00 = "UYpop00"
VEpop00 = "VEpop00"
UYsurvey1_shp = "UYsurvey1.shp"
VEcensus3_shp = "VEcensus3.shp"
CI3pop00 = "CI3pop00"
CO3pop00 = "CO3pop00"
CR3pop00 = "CR3pop00"
EC3pop00 = "EC3pop00"
COcensus3_shp = "COcensus3.shp"
ECcensus3_shp = "ECcensus3.shp"
CIcensus3_shp = "CIcensus3.shp"
CRcensus3_shp = "CRcensus3.shp"

ARp_dbf = "ARp.dbf"
BLp_dbf = "BLp.dbf"
BRp_dbf = "BRp.dbf"
CAp_dbf = "CAp.dbf"
CIp_dbf = "CIp.dbf"
COp_dbf = "COp.dbf"
ECp_dbf = "ECp.dbf"
ESp_dbf = "ESp.dbf"
GTp_dbf = "GTp.dbf"
HOp_dbf = "HOp.dbf"
MXp_dbf = "MXp.dbf"
NUp_dbf = "NUp.dbf"
PAp_dbf = "PAp.dbf"
PEp_dbf = "PEp.dbf"
PMp_dbf = "PMp.dbf"
USp_dbf = "USp.dbf"
UYp_dbf = "UYp.dbf"
VEp_dbf = "VEp.dbf"
CI3p_dbf = "CI3p.dbf"
CO3p_dbf = "CO3p.dbf"
CR3p_dbf = "CR3p.dbf"
EC3p_dbf = "EC3p.dbf"

pop00 = "pop00"
glup00ag_alpha1_asc = "glup00ag_alpha1.asc"
# glup00ag_alpha1_asc is the name of the file to be downloaded from http://sedac.ciesin.columbia.edu/gpw

# Process: ASCII to Raster...
gp.ASCIIToRaster_conversion(glup00ag_alpha1_asc, pop00, "INTEGER")

# Process: Define Projection...
gp.DefineProjection_management(pop00, "GEOGCS['GCS_WGS_1984',DATUM['D_WGS_1984',SPHEROID['WGS_1984',6378137.0,298.257223563]],PRIMEM['Greenwich',0.0],UNIT['Degree',0.0174532925199433]]")

# Process: Build Raster Attribute Table...
gp.BuildRasterAttributeTable_management(pop00, "NONE")

# Process: Zonal Statistics as Table...
gp.ZonalStatisticsAsTable_sa(BLsurvey2_shp, "MUN", pop00, BLpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(BLpop00, BLp_dbf, "")

# Process: Zonal Statistics as Table (2)...
gp.ZonalStatisticsAsTable_sa(BRcensus3_shp, "cid", pop00, BRpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(BRpop00, BRp_dbf, "")

# Process: Zonal Statistics as Table (3)...
gp.ZonalStatisticsAsTable_sa(CAcensus1_shp, "CA1codes_A", pop00, CApop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(CApop00, CAp_dbf, "")

# Process: Zonal Statistics as Table (4)...
gp.ZonalStatisticsAsTable_sa(CIadmin1_shp, "CI1codes_A", pop00, CIpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(CIpop00, CIp_dbf, "")

# Process: Zonal Statistics as Table (5)...
gp.ZonalStatisticsAsTable_sa(COsurvey1_shp, "COcodes_A", pop00, COpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(COpop00, COp_dbf, "")

# Process: Zonal Statistics as Table (6)...
gp.ZonalStatisticsAsTable_sa(EC_survey1_shp, "EC1codes_A", pop00, ECpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(ECpop00, ECp_dbf, "")

# Process: Zonal Statistics as Table (7)...
gp.ZonalStatisticsAsTable_sa(ESsurvey3_shp, "EScodes_AD", pop00, ESpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(ESpop00, ESp_dbf, "")

# Process: Zonal Statistics as Table (8)...
gp.ZonalStatisticsAsTable_sa(GTsurvey3_shp, "MUN", pop00, GTpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(GTpop00, GTp_dbf, "")

# Process: Zonal Statistics as Table (9)...
gp.ZonalStatisticsAsTable_sa(HOsurvey3_shp, "MUN", pop00, HOpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(HOpop00, HOp_dbf, "")

# Process: Zonal Statistics as Table (10)...
gp.ZonalStatisticsAsTable_sa(MXcensus3_shp, "MXcodes_AD", pop00, MXpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(MXpop00, MXp_dbf, "")

# Process: Zonal Statistics as Table (11)...
gp.ZonalStatisticsAsTable_sa(PAsurvey3_shp, "MUN", pop00, PApop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(PApop00, PAp_dbf, "")

# Process: Zonal Statistics as Table (12)...
gp.ZonalStatisticsAsTable_sa(PEsurvey3_shp, "CODIGO_DIS", pop00, PEpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(PEpop00, PEp_dbf, "")

# Process: Zonal Statistics as Table (13)...
gp.ZonalStatisticsAsTable_sa(PMcensus3_shp, "PMcodes.ADMIN3", pop00, PMpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(PMpop00, PMp_dbf, "")

# Process: Zonal Statistics as Table (14)...
gp.ZonalStatisticsAsTable_sa(UScensus3_shp, "cid", pop00, USpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(USpop00, USp_dbf, "")

# Process: Zonal Statistics as Table (15)...
gp.ZonalStatisticsAsTable_sa(UYsurvey1_shp, "UYcodes_A", pop00, UYpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(UYpop00, UYp_dbf, "")

# Process: Zonal Statistics as Table (16)...
gp.ZonalStatisticsAsTable_sa(VEcensus3_shp, "VE3codes.CENS_MUN", pop00, VEpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(VEpop00, VEp_dbf, "")


# Process: Zonal Statistics as Table...
gp.ZonalStatisticsAsTable_sa(ARcensus3_shp, "codes4AR_M", pop00, ARpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(ARpop00, ARp_dbf, "")


# Process: Zonal Statistics as Table...
gp.ZonalStatisticsAsTable_sa(NUsurvey3_shp, "MUN", pop00, NUpop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(NUpop00, NUp_dbf, "")


# Process: Zonal Statistics as Table...
gp.ZonalStatisticsAsTable_sa(CIcensus3_shp, "cid", pop00, CI3pop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(CI3pop00, CI3p_dbf, "")


# Process: Zonal Statistics as Table...
gp.ZonalStatisticsAsTable_sa(COcensus3_shp, "cid", pop00, CO3pop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(CO3pop00, CO3p_dbf, "")


# Process: Zonal Statistics as Table...
gp.ZonalStatisticsAsTable_sa(CRcensus3_shp, "CRed_codes.CENS_PROV", pop00, CR3pop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(CR3pop00, CR3p_dbf, "")



# Process: Zonal Statistics as Table...
gp.ZonalStatisticsAsTable_sa(ECcensus3_shp, "cid", pop00, EC3pop00, "DATA")

# Process: Table Select...
gp.TableSelect_analysis(EC3pop00, EC3p_dbf, "")
